# A module for student data

# Time needed to calculate age
import time

# Relevant properties representing a student
class Student:
    # The init method is called every time a new object is created
    # self refers to that particular object
    def __init__(self, myName, myNumber):
        self.__name = myName
        self.__id = myNumber
        self.__grades = [ ]
        self.__courses = [ ]
        self.__birthyear = 0

    # A getter-setter pair, one method to add data, another to read it
    def add_course(self, course):
        self.__courses.append(course)
    def get_courses(self):
        return self.__courses

    # A more complex getter-setter pair, age is verified to be
    # within bounds and a succes code returned
    def add_grade(self, grade):
        if 0 <= grade <= 5:
            self.__grades.append(grade)
            return True
        else:
            return False

    def get_grades(self):
        return self.__grades

    # Here the implementation is hidden, age is set and read,
    # but the actual data stored is birthdate and age
    # calculated from that when needed
    def set_age(self, age):
        if (-0.75 < age < 150):
            self.__birthyear =  time.localtime().tm_year - age
            return True
        else:
            return False
        
    def get_age(self):
        age = time.localtime().tm_year - self.__birthyear
        return age

    def get_name(self):
        return self.__name
    def get_id(self):
        return self.__id

    # This method allows the object to be printed
    # (that is, we can define what to print)
    def __str__(self):
        return f"ID: {self.__id} Name: {self.__name}"

